controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Autor;
use app\models\LoginForm;
use app\models\Noticia;
use app\models\Seccion;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['*'],
                'rules' => [
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['?'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Mostrar las noticias de portada
     *
     * @return string
     */
    public function actionIndex()
    {
        // necesito recuperar todas las
        // noticias de la base de datos
        $consulta = Noticia::find(); // consulta sin ejecutar (activeQuery)

        //$datos = $consulta->all();  // array modelos de noticias
        //$datos = $consulta->asArray()->all(); // array de noticias

        // noticias de portada
        $datos = $consulta
            ->where(["portada" => 1]) // seleccionar
            //->where("portada=1") // seleccionar
            ->all(); // ejecutar

        return $this->render('index', [
            "datos" => $datos,
            "titulo" => "Noticias de Portada"
        ]);
    }
    public function actionViewnoticia($idNoticia)
    {
        $consulta = Noticia::find()->where([
            "idNoticia" => $idNoticia
        ]); // select * from noticia where idNoticia=1

        $dato = $consulta->one();

        return $this->render("verNoticia", [
            "dato" => $dato
        ]);
    }

    public function actionSecciones()
    {
        $secciones = Seccion::find()->all(); // select * from seccion

        // le mando a la vista secciones
        // todas las secciones de la base de datos
        return $this->render('secciones', [
            "secciones" => $secciones
        ]);

        //return $this->render('secciones', compact("secciones"));
    }

    public function actionSeccion($id)
    {
        // listar las noticias cuya seccion 
        // sea el id mandado por la URL
        $noticias = Noticia::find()
            ->where(["seccion" => $id])
            ->all();

        // saco todos los datos de la seccion seleccionada
        $seccion = Seccion::find()->where(["id" => $id])->one();
        //$seccion = Seccion::findOne($id);

        // aprovecho la vista index para mostrar las noticias 
        // de una seccion determinada
        return $this->render('index', [
            "datos" => $noticias,
            "titulo" => "Noticias de la Seccion " . $seccion->nombre
        ]);
    }

    public function actionAutores()
    {
        // obtengo todos los autores
        $autores = Autor::find()->all();

        // le mando a la vista todos los autores
        return $this->render("autores", [
            "autores" => $autores
        ]);
    }

    public function actionAutor($id)
    {
        // recuperar las noticias de ese autor (el que le mando por la URL)
        $noticias = Noticia::find()->where(["autor" => $id])->all();

        // obtener todos los datos del autor seleccionado
        $autor = Autor::find()->where(["id" => $id])->one();

        // aprovecho la vista index para mostrar las noticias 
        // de una seccion determinada
        return $this->render('index', [
            "datos" => $noticias,
            "titulo" => "Noticias de " . $autor->nombre
        ]);
    }
    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }
}

views/site/_noticia.php
<?php
    use yii\helpers\Html;
?>
<div class="col-lg-4 mb-3">
    <h2><?= $dato->titular ?></h2>
<br>
    <p><?= $dato->textoCorto ?></p>
    <br>
    <div><?= Html::img(
        "@web/imgs/{$dato->foto}" , // ruta  + nombre
        [
            "class" => 'col-lg-8'
        ] // atributos html
        ) 
        ?></div>
        <br>
    <div><?= Html::a(
            "Ver noticia completa", // texto del enlace
            [
                'site/viewnoticia', // controlador/accion
                'idNoticia'=>$dato->idNoticia // parametro a enviar por URL
            ] ,
            [
                "class" => "btn btn-primary" // atributos
            ]
            ) ?></div>
</div>

views/site/autores.php
<?php

use yii\helpers\Html;


?>
<div class="jumbotron text-center bg-transparent mt-5 mb-5">
    <h1 class="display-4">Autores</h1>
</div>

<div class="row">
    <?php
    foreach ($autores as $autor) {
    ?>
        <div class="col-4 mt-3">
            <div class="card bg-white text-dark">
                <?= Html::img('@web/imgs/autores/' . $autor->foto, ['class' => 'm-2']) ?>
                <div class="card-body">
                    <h5 class="card-title"><?= $autor->nombre ?></h5>
                    <?= Html::a('ver noticias', ['site/autor', 'id' => $autor->id], ['class' => 'btn btn-secondary']) ?>
                </div>
            </div>
        </div>
    <?php
    }
    ?>
</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

use yii\helpers\Html;

$this->title = 'Noticias';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4"><?= isset($titulo) ? $titulo : "Noticias" ?></h1>
    </div>

    <div class="body-content">
        <div class="row">
            <?php
            foreach ($datos as $dato) {
                echo $this->render("_noticia", [
                    "dato" => $dato
                ]);
            }
            ?>
        </div>
    </div>
</div>

views/site/login.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap5\ActiveForm $form */

/** @var app\models\LoginForm $model */

use yii\bootstrap5\ActiveForm;
use yii\bootstrap5\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <div class="row">
        <div class="col-lg-5">

            <?php $form = ActiveForm::begin([
                'id' => 'login-form',
                'fieldConfig' => [
                    'template' => "{label}\n{input}\n{error}",
                    'labelOptions' => ['class' => 'col-lg-1 col-form-label mr-lg-3'],
                    'inputOptions' => ['class' => 'col-lg-3 form-control'],
                    'errorOptions' => ['class' => 'col-lg-7 invalid-feedback'],
                ],
            ]); ?>

            <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

            <?= $form->field($model, 'password')->passwordInput() ?>

            <?= $form->field($model, 'rememberMe')->checkbox([
                'template' => "<div class=\"custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
            ]) ?>

            <div class="form-group">
                <div>
                    <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
                </div>
            </div>

            <?php ActiveForm::end(); ?>

            <div style="color:#999;">
                You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
                To modify the username/password, please check out the code <code>app\models\User::$users</code>.
            </div>

        </div>
    </div>
</div>

views/site/secciones.php
<?php

use yii\helpers\Html;


?>
<div class="jumbotron text-center bg-transparent mt-5 mb-5">
    <h1 class="display-4">Secciones</h1>
</div>

<div class="row">
    <?php
    foreach ($secciones as $seccion) {
    ?>
        <div class="col-4 mt-3">
            <div class="card bg-white text-dark">
                <?= Html::img('@web/imgs/secciones/' . $seccion->foto, ['class' => 'm-2']) ?>
                <div class="card-body">
                    <h5 class="card-title"><?= $seccion->nombre ?></h5>
                    <?= Html::a('ver noticias', ['site/seccion', 'id' => $seccion->id], ['class' => 'btn btn-secondary']) ?>
                </div>
            </div>
        </div>
    <?php
    }
    ?>
</div>

views/site/verNoticia.php
<?php
    use yii\helpers\Html;
?>
<div>
    <?= $dato->titular ?>
</div>
<div>
    <?= $dato->textoLargo ?>
</div>
<div>
    <?= Html::img(
        "@web/imgs/{$dato->foto}",[
            "class" => "col-lg-6"
        ]
    ) ?>
</div>
<div>
    <?= $dato->autor ?> -  <?= $dato->fecha ?>
</div>
<div>
    <?= $dato->seccion ?>
</div>